/*!
Copyright © 2024 Open Text Corporation, All Rights Reserved.

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
import { Config } from '../../models/control-config';
import { OcpdComponentRegister } from '../../singletons/ocpd-component-register';
import { OcpdControlsRenderHelper } from '../../singletons/ocpd-controls-render-helper';
import { OcpdComponentMapper } from '../../singletons/ocpd-component-mapper';
import { OcpdPropertyChanged } from '../../singletons/ocpd-property-changed';
import { OcpdStringLocalizationHelper } from '../../singletons/ocpd-string-localization';
import { OcpdAvailableComponents } from '../../singletons/ocpd-available-components';
import { OcpdControlsHelper } from '../../singletons/ocpd-controls-helper';
import { OcpdItemManagerHelper } from '../../singletons/ocpd-item-manager-helper';
import { OcpdFormClientAPIService } from '../../singletons/ocpd-form-client-api-service';
import { OcpdFormSchemaManager } from '../../singletons/ocpd-form-schema-manager';
export declare abstract class OcpdBaseElement extends HTMLElement {
    _ocpdFormSchemaManager: OcpdFormSchemaManager;
    _ocpdComponentMapper: OcpdComponentMapper;
    _ocpdItemManagerHelper: OcpdItemManagerHelper;
    _ocpdComponentRegister: OcpdComponentRegister;
    _ocpdControlsRenderHelper: OcpdControlsRenderHelper;
    _ocpdDateLocalizationHelper: any;
    _ocpdNumberLocalizationHelper: any;
    _ocpdStringLocalizationHelper: OcpdStringLocalizationHelper;
    _ocpdPropertyChanged: OcpdPropertyChanged;
    _ocpdControlsHelper: OcpdControlsHelper;
    _ocpdAvailableComponents: OcpdAvailableComponents;
    _ocpdFormClientAPIService: OcpdFormClientAPIService;
    _config: Config;
    _isContainer: boolean;
    isRootContainer: boolean;
    disabled: boolean;
    sendMessageToFormClient: any;
    originalStyleDisplayValue: string;
    static get tagName(): string;
    attributeChangedCallback(name: any, oldValue: any, newValue: any): Promise<void>;
    isChildOfMultiPanelControl(container: any): boolean;
    themeChanged(themeName: string): void;
    getCssStyle(themeName: string): HTMLStyleElement;
    selectCSSForTheme(themeName: string, OTClassicCss: string, JATOCss: string): string;
    getCssString(themeName: string): string;
    getCss(themeName: any): string;
    cascadeAttributeChange(attributeName: any, attributeValue: any): Generator<Node, void, unknown>;
    getAllThemeableContainers(): NodeList;
    get dataTheme(): string;
    isPartOfContainerControl(container: any): boolean;
    hasParentContainerWidthBeenReduced(newValue: number, oldValue: number): boolean;
    isChildContainerWidthGreaterThanNewParentSize(container: any, newValue: number): boolean;
    static get observedAttributes(): string[];
    dataUpdate(_prop: any): void;
    protected constructor();
    getCommonCSSForTheme(themeName: any): any;
    addCommonStyles(themeName: any): void;
    getInitialCSSVariableValue(variableName: any, themeName: any, themes: any): any;
    addCSSVariableFromTheme(themeName: any): void;
    setCustomCssProperty(cssText: any): void;
    getRepeatingValue(valueArray: any): any;
    get isInGrid(): boolean;
    get isInRepeat(): boolean;
    get itemId(): string;
    set itemId(itemId: string);
    get dataSource(): string;
    get isVirtualControl(): boolean;
    get virtualControlId(): string;
    get numberOfColumns(): number;
    set dataSource(source: string);
    get dataLocale(): string;
    get dataReadOnly(): string;
    get dataType(): string;
    get isContainer(): boolean;
    set isContainer(value: boolean);
    get rowIndex(): string;
    get colIndex(): string;
    get isGhostControl(): boolean;
    get elementId(): string;
    get config(): Config;
    set config(newValue: Config);
    get isReadOnly(): boolean;
    get parentHasVirtualId(): boolean;
    getParentHost(): any;
    isStyleDefinedByHostApp(name: any, defaultStyle: any): string;
    getBaseCss(baseCss: any): string;
    isObject(val: any): boolean;
    abstract render(config: Config): void;
    getCommonStyle(themeName: any): HTMLStyleElement;
    connectedCallback(): void;
    disconnectedCallback(): void;
    addResizableAttribute(): void;
    addSelectableAttribute(): void;
    detached(): void;
    connectedCallbackComplete(): void;
    addEventListeners(): void;
    removeEventListeners(): void;
    isAdoptedStyleSheetsSupported(): boolean;
    isControlFocused(controls: any): any;
    isCtrlKey(event: any): boolean;
    getAriaLabel(): string;
    changeLocale(): void;
    isComponentInDom(): boolean;
    getLocalizedString(uiPropertyPath: any, config?: any): any;
    getEncodedUrl(url: string): string;
}
